#!/usr/bin/python3

import sys,os
import klayout.db as db

import FreeCAD
import importDXF, Draft, PartDesign

argv=sys.argv

tech_fname=None
for i,arg in enumerate(argv):
  if arg=="-stack":
     argv.pop(i)
     tech_fname=argv.pop(i)
     tech_fname1,fext=os.path.splitext(tech_fname)
     if fext  != '.stack':
        print(argv[argl-1]+' is not a stack file')
        exit()
     break


argl=len(argv)
if argl!=2:
    print("Syntax:  layout2fc  -stack stack_file  dxf_file")
    exit()
fname=argv[argl-1]
fname1,fext=os.path.splitext(fname)
if fext.lower()  != '.dxf':
    print(argv[argl-1]+' is not a dxf file')
    exit()


if tech_fname==None:
    print("Syntax:  layout2fc  -stack stack_file  dxf_file")

if not os.path.exists(tech_fname):
    print(tech_fname+"  not found")
    exit()

if not os.path.exists(fname):
    print(fname+"  not found")
    exit()

stack={}
with open(tech_fname, 'r') as f:
    for line in f:
        line=line.split('#')[0]
        [ldata,zdata]=line.split(':')
        [z0,z1]=zdata.split()
        stack[ldata]=[z0,z1]

stack_scale=1
if 'scale' in stack.keys():
   stack_scale=float(stack['scale'][0])

layout = db.Layout()
layout.read(fname)
for c in layout.each_cell():
   if c.name=="TOP":
      c.flatten(-1,True)
for c in layout.each_cell():
   if c.name!="TOP":
      layout.delete_cell(c.cell_index)

doc = FreeCAD.newDocument()
doc.saveAs(fname1+'.FCStd')

#import pdb
#pdb.set_trace()

for li in layout.layer_indexes():
   linfo = layout.get_info(li)
   if linfo.layer==0 or linfo.name=="_0" or linfo.name=="L0D0_0":
     continue
   ldata=str(linfo.layer)+"/"+str(linfo.datatype)
   if ldata not in stack.keys():
      continue
   [z0,z1]=stack[ldata]
   z0=float(z0)*stack_scale
   z1=float(z1)*stack_scale
   fname_li=fname1+"_"+linfo.name
   opt = db.SaveLayoutOptions()
   opt.format="DXF"
   # specifies to write only layer index "li" with target layer/datatype taken 
   # from the original "linfo":
   opt.add_layer(li, linfo)
   layout.write(fname_li+".dxf", opt)
   print(fname_li+".dxf" + " written.")
   body=doc.addObject("PartDesign::Body", linfo.name)
   body.Visibility = True
   existings = doc.Objects
   importDXF.insert(fname_li+".dxf",doc.Name)
   newObjs = [o for o in doc.Objects if o not in existings]
   for obj in newObjs:
     sketch = Draft.make_sketch(obj, autoconstraints=True)
     doc.removeObject(obj.Name)
     if sketch==None:
         continue
     body.Group += [sketch]
     pad=doc.addObject('PartDesign::Pad','Pad_'+sketch.Name)
     pad.Profile=sketch
     pad.NewSolid=True
     pad.Length = z1-z0
     pad.Direction = (0, 0, 1)
     pad.ReferenceAxis = None
     pad.AlongSketchNormal = 0
     pad.Type = 0
     pad.UpToFace = None
     pad.Reversed = 0
     pad.Offset = z0
     pad.Visibility =True
     body.Group += [pad]


doc.save()
FreeCAD.closeDocument(doc.Name)

